/// <reference path="../Definitions/jquery.d.ts"/>
/// <reference path="../Definitions/SharePoint.d.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
// http://www.typescriptlang.org/Playground/
var TypeChecking;
(function (TypeChecking) {
    function f1(x, y) {
        return x + y;
    }

    function f2(x, y) {
        return x + y;
        //return "";
    }

    f1(1, 2);
    f1("xx", "yy");
    f2(1, 2);
})(TypeChecking || (TypeChecking = {}));

var Interfaces;
(function (Interfaces) {
    var Cat = (function () {
        function Cat(name) {
            this.name = "";
            this.name = name;
            this.age = 3;
        }
        Cat.prototype.speak = function () {
            console.log("meow!");
        };
        return Cat;
    })();
    Interfaces.Cat = Cat;
    ;

    var Lion = (function (_super) {
        __extends(Lion, _super);
        function Lion() {
            _super.apply(this, arguments);
        }
        Lion.prototype.speak = function () {
            console.log("rawr!");
        };
        return Lion;
    })(Cat);
    Interfaces.Lion = Lion;

    var catGarfield = new Cat("Garfield");

    // Cat is a Type - so this assignment is invalid.
    //var c3: Cat = { name: "Sylvester", speak: function () { } };
    // Interface however, are type-checked by "shape" of the object.  And this is perfectly fine.
    var c2 = { name: "Sylvester", speak: function () {
        } };

    var l1 = new Lion("Simba");
    l1.speak();
})(Interfaces || (Interfaces = {}));

// ok... this is cool.  what about JQuery
var JQueryModule;
(function (JQueryModule) {
    var MyClass = (function () {
        function MyClass() {
        }
        MyClass.prototype.MyMethod1 = function () {
            // jQuery demo
            var _this = this;
            $("div.class").addClass("xx");
            $("div.class").addClass("xxx").removeClass("yyy");

            $.ajax({
                url: "/_vti_bin/listdata.svc/Announcement",
                success: function (data, status, xhr) {
                }
            });

            $("div.class").click(function (e) {
                e.preventDefault();
                this; // this is any
            });

            // ECMA Script v6 arrow function syntax - looks just like C# delegates
            $("a.class").click(function (e) {
                e.preventDefault();
                _this; // this is scoped to the current instance of JQClass
            });
        };
        return MyClass;
    })();
})(JQueryModule || (JQueryModule = {}));

/*
module Interfaces {
//  interface, and modules are Open, so you can extend an interface in a different file.
//  this is most useful for describing javascript libraries, e.g. jQuery, and then jQuery.UI that extends jQuery.
export interface Feline {
flip?: () => any;
}
}
*/
var demo;
(function (demo) {
    function ShowDialog() {
        // see Definitions
        var options = {
            url: "/Pages/demo.aspx",
            title: "Demo Page"
        };

        SP.UI.ModalDialog.showModalDialog(options);

        // break Url argument
        var dialog = SP.UI.ModalDialog.showModalDialog({ url: "/Pages/demo.aspx", title: "Demo Page" });

        setTimeout(function () {
            dialog.close(SP.UI.DialogResult.OK);
        }, 5000);

        return demo.MyMethod1x();
    }
    demo.ShowDialog = ShowDialog;

    function MyPrivateMethod1() {
        return 0;
    }

    function MyMethod1x() {
        return 1;
    }
    demo.MyMethod1x = MyMethod1x;
})(demo || (demo = {}));
//# sourceMappingURL=demo.js.map
